IGP Flexible Algorithms Reverse Affinity Constraint
RFC 9917
Peter Psenak
Cisco Systems
Apollo Business Center
Mlynske nivy 43
Bratislava
82109
Slovakia
ppsenak@cisco.com
Jakub Horn
Cisco Systems
Milpitas
95035
CA
United States of America
jakuhorn@cisco.com
Amit Dhamija
Arrcus
amitd@arrcus.com
January 2026
RTG
lsr
An IGP Flexible Algorithm (Flex-Algorithm) enables the computation of constraint-based paths within an IGP domain, allowing operators to influence path selection according to administrative policies. This document defines an extension to Flex-Algorithm that allows the inclusion or exclusion of links from path computation based on Administrative Groups (also known as link affinities) associated with the reverse direction of the path under computation.
This document updates RFCs 9350 and 9843 by introducing the new IANA registry that specifies the ordered set of rules that are used to prune links from the topology during the Flex-Algorithm path computation.
Introduction
IGP protocols historically computed the best paths over the network solely based on the IGP metric assigned to the links. An IGP Flex-Algorithm as specified in [RFC9350] allows IGPs to compute constraint-based paths. Several mechanisms to include or exclude the link during the Flex-Algorithm path calculation have been defined already:
- link inclusion or exclusion based on the presence of a specific Admin Group(s) [RFC9350]
- link exclusion based on the presence of a specific Shared Risk Link Group (SRLG) [RFC9350]
- link exclusion based on minimum bandwidth [RFC9843]
- link exclusion based on maximum delay [RFC9843]
This document extends IGP Flex-Algorithm with additional constraints for inclusion or exclusion of links in the path based on Admin Groups associated with the reverse direction of the Shortest Path First (SPF) computation.
This document updates [RFC9350] and [RFC9843] by creating the new IANA registry that specifies the ordered set of rules that are used to prune links from the topology during the Flex-Algorithm path computation (refer to Section 12.3.1).
The term OSPF in this document is used to cover both OSPFv2 and OSPFv3 protocols.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Use Case Example
The Flexible Algorithm Definition (FAD) can specify Extended Administrative Groups that are used by the operator to include or exclude links during the Flex-Algorithm path computation [RFC9350]. These link Extended Administrative Groups are checked in the path direction of the SPF computation, e.g., in the direction from the root vertex toward vertices of increasing distance.
In certain scenarios, it is beneficial to evaluate the Extended Administrative Groups associated with the reverse direction of a link, rather than solely those in the direction of path computation. Consider a point-to-point link represented as a pair of directed edges between two nodes, A and B. When computing a path from A to B, issues such as input errors on the link, detectable only at the receiving node B, may be operationally significant. An operator might monitor metrics like Cyclic Redundancy Check (CRC) errors or other input-related faults at node B and apply thresholds over a defined observation period. If such a threshold is exceeded, node B may locally assign specific Extended Administrative Groups to the link in the direction from B to A.
To accommodate this operational intent, the Flex-Algorithm can be extended to inspect the Extended Administrative Groups of the reverse-direction edge (from B to A) when evaluating the forward-direction edge (from A to B) during path computation. This enables the exclusion of links from the computed topology based on conditions detected at the far end of the link, improving network reliability and policy control.
Deployment Consideration
Threshold-based setting of the link Extended Administrative Groups must be done with care to avoid excessive flooding and constant Flex-Algorithm path recalculation.
One possible approach is to use two different thresholds when setting and unsetting the Extended Administrative Group on the link. For example, when setting the Extended Administrative Group on the link based on the percentage of certain incoming errors, higher threshold is used for setting and lower threshold is used for unsetting the Extended Administrative Group on the link.
Many implementations provide a throttling mechanism that limits the rate at which the Link State PDU (LSP) in case of IS-IS, or Link State Advertisement (LSA) in case of OSPFv2 and OSPFv3, is updated at the originator. Such mechanism is typically not specific to any particular link attribute, but rather considers any change in the LSP or LSA. Application of such throttling mechanism can also be used to avoid frequent changes in the setting of the Extended Administrative Group on a link to affect the stability of the receivers.
IS-IS Flexible Algorithm Exclude Reverse Admin Group Sub-TLV
The IS-IS Flexible Algorithm Exclude Reverse Admin Group (FAERAG) Sub-TLV is used to advertise the exclude rule that is used during the Flex-Algorithm path calculation as specified in Section 11.
The IS-IS FAERAG Sub-TLV is a sub-TLV of the IS-IS FAD Sub-TLV. It has the following format:

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|      Type     |    Length     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Extended Admin Group                     |
+-                                                             -+
|                            ...                                |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
where:
Type (1 octet):
10
Length (1 octet):
Variable, dependent on the size of the Extended Admin Group. The length MUST be a multiple of 4 octets. If the length is not a multiple of 4 octets, the entire sub-TLV MUST be ignored by the receiver.
Extended Administrative Group:
Extended Administrative Group as defined in [RFC7308].
The IS-IS FAERAG Sub-TLV MUST NOT appear more than once in a single IS-IS FAD Sub-TLV. If it appears more than once, the IS-IS FAD Sub-TLV MUST be ignored by the receiver.
The IS-IS FAERAG Sub-TLV MUST NOT appear more than once in the set of FAD Sub-TLVs for a given Flex-Algorithm from a given IS. If it appears more than once in such set, the IS-IS FAERAG Sub-TLV in the first occurrence in the lowest-numbered LSP from a given IS MUST be used and any other occurrences MUST be ignored by the receiver.
IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV
The IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV is used to advertise the include-any rule that is used during the Flex-Algorithm path calculation as specified in Section 11.
The format of the IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV is identical to the format of the FAERAG Sub-TLV in Section 5.
IANA has assigned Type value of 11 for the IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV.
The IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV MUST NOT appear more than once in a single IS-IS FAD Sub-TLV. If it appears more than once, the IS-IS FAD Sub-TLV MUST be ignored by the receiver.
The IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV MUST NOT appear more than once in the set of FAD Sub-TLVs for a given Flex-Algorithm from a given IS. If it appears more than once in such set, the IS-IS Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV in the first occurrence in the lowest-numbered LSP from a given IS MUST be used and any other occurrences MUST be ignored by the receiver.
IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV
The IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV is used to advertise the include-all rule that is used during the Flex-Algorithm path calculation as specified in Section 11.
The format of the IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV is identical to the format of the FAERAG Sub-TLV in Section 5.
IANA has assigned Type value of 12 for the IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV.
The IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV MUST NOT appear more than once in a single IS-IS FAD Sub-TLV. If it appears more than once, the IS-IS FAD Sub-TLV MUST be ignored by the receiver.
The IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV MUST NOT appear more than once in the set of FAD Sub-TLVs for a given Flex-Algorithm from a given IS. If it appears more than once in such set, the IS-IS Flexible Algorithm Include-All Reverse Admin Group Sub-TLV in the first occurrence in the lowest-numbered LSP from a given IS MUST be used and any other occurrences MUST be ignored by the receiver.
OSPF Flexible Algorithm Exclude Reverse Admin Group Sub-TLV
The OSPF Flexible Algorithm Exclude Reverse Admin Group (FAERAG) Sub-TLV is used to advertise the exclude rule that is used during the Flex-Algorithm path calculation as specified in Section 11.
The OSPF FAERAG Sub-TLV is a sub-TLV of the OSPF FAD TLV. It has the following format:

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|              Type             |             Length            |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Extended Admin Group                     |
+-                                                             -+
|                            ...                                |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
where:
Type (2 octets):
10
Length (2 octets):
Variable, dependent on the size of the Extended Admin Group. The length MUST be a multiple of 4 octets. If the length is not a multiple of 4 octets, the entire sub-TLV MUST be ignored by the receiver.
Extended Administrative Group:
Extended Administrative Group as defined in [RFC7308].
The OSPF FAERAG Sub-TLV MUST NOT appear more than once in an OSPF FAD TLV. If it appears more than once, the OSPF FAD TLV MUST be ignored by the receiver.
OSPF Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV
The OSPF Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV is used to advertise the include-any rule that is used during the Flex-Algorithm path calculation as specified in Section 11.
The format of the OSPF Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV is identical to the format of the OSPF FAERAG Sub-TLV in Section 8.
IANA has assigned Type value of 11 for the OSPF Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV.
The OSPF Flexible Algorithm Include-Any Reverse Admin Group Sub-TLV MUST NOT appear more than once in an OSPF FAD TLV. If it appears more than once, the OSPF FAD TLV MUST be ignored by the receiver.
OSPF Flexible Algorithm Include-All Reverse Admin Group Sub-TLV
The OSPF Flexible Algorithm Include-All Reverse Admin Group Sub-TLV is used to advertise the include-all rule that is used during the Flex-Algorithm path calculation as specified in Section 11.
The format of the OSPF Flexible Algorithm Include-All Reverse Admin Group Sub-TLV is identical to the format of the OSPF FAERAG Sub-TLV in Section 8.
IANA has assigned Type value of 12 for the OSPF Flexible Algorithm Include-All Reverse Admin Group Sub-TLV.
The OSPF Flexible Algorithm Include-All Reverse Admin Group Sub-TLV MUST NOT appear more than once in an OSPF FAD TLV. If it appears more than once, the OSPF FAD TLV MUST be ignored by the receiver.
Calculation of Flexible Algorithm Paths
The following procedures augment the rules defined in Section 13 of [RFC9350] by introducing additional constraints based on Administrative Groups (AGs) associated with the reverse direction of a link.
- Check if any exclude reverse Admin Group rule is part of the Flex-Algorithm definition. If such exclude rule exists, check if any Admin Group that is part of the exclude rule is also set on the link in the reverse direction. If such Admin Group is set on the link in the reverse direction, the link MUST be pruned from the computation.
- Check if any include-any reverse Admin Group rule is part of the Flex-Algorithm definition. If such include-any rule exists, check if any Admin Group that is part of the include-any rule is also set on the link in the reverse direction. If no such Admin Group is set on the link in the reverse direction, the link MUST be pruned from the computation.
- Check if any include-all reverse Admin Group rule is part of the Flex-Algorithm definition. If such include-all rule exists, check if all Admin Groups that are part of the include-all rule are also set on the link in the reverse direction. If all such Admin Groups are not set on the link in the reverse direction, the link MUST be pruned from the computation.
Please see rules 8, 9, and 10 in Section 12.3 for these added rules.
IANA Considerations
Sub-Sub-TLVs for Flexible Algorithm Definition Sub-TLV
IANA has registered the following in the "IS-IS Sub-Sub-TLVs for Flexible Algorithm Definition Sub-TLV" registry under the "IS-IS TLV Codepoints" registry group:
Type:
10
Description:
Flexible Algorithm Exclude Reverse Admin Group
MP:
n
Reference:
RFC 9917, Section 5
Type:
11
Description:
Flexible Algorithm Include-Any Reverse Admin Group
MP:
n
Reference:
RFC 9917, Section 6
Type:
12
Description:
Flexible Algorithm Include-All Reverse Admin Group
MP:
n
Reference:
RFC 9917, Section 7
OSPF Flexible Algorithm Definition TLV Sub-TLV Registry
This document makes the following registration in the "OSPF Flexible Algorithm Definition TLV Sub-TLVs" registry under the "Open Shortest Path First (OSPF) Parameters" registry group:
Type:
10
Description:
Flexible Algorithm Exclude Reverse Admin Group
Reference:
RFC 9917, Section 8
Type:
11
Description:
Flexible Algorithm Include-Any Reverse Admin Group
Reference:
RFC 9917, Section 9
Type:
12
Description:
Flexible Algorithm Include-All Reverse Admin Group
Reference:
RFC 9917, Section 10
IGP Flex-Algorithm Path Computation Rules Registry
IANA has created a new registry called "IGP Flex-Algorithm Path Computation Rules" within the "Interior Gateway Protocol (IGP) Parameters" registry group. The registration procedure for the new registry is Expert Review [RFC8126]. Section 12.3.1 provides guidance for designated experts.
The "IGP Flex-Algorithm Path Computation Rules" registry specifies the ordered set of rules that are used to prune links from the topology during the Flex-Algorithm path computation.
There is no upper bound on the number of rules that the registry supports.
In Table 1, "FAEMB" means "Flex-Algorithm Exclude Minimum Bandwidth", and "FAEMD" means "Flex-Algorithm Exclude Maximum Delay".
IGP Flex-Algorithm Path Calculation Rules
Sequence Number | Description | Reference
1 | Check if any exclude Administrative Group rule is part of the Flex-Algorithm Definition. If such exclude rule exists, check if any color that is part of the exclude rule is also set on the link. If such a color is set, the link MUST be pruned from the computation. | Section 13 of [RFC9350]
2 | Check if any exclude SRLG rule is part of the Flex-Algorithm Definition. If such exclude rule exists, check if the link is part of any SRLG that is also part of the SRLG exclude rule. If the link is part of such SRLG, the link MUST be pruned from the computation. | Section 13 of [RFC9350]
3 | Check if any include-any Administrative Group rule is part of the Flex-Algorithm Definition. If such include-any rule exists, check if any color that is part of the include-any rule is also set on the link. If no such color is set, the link MUST be pruned from the computation. | Section 13 of [RFC9350]
4 | Check if any include-all Administrative Group rule is part of the Flex-Algorithm Definition. If such include-all rule exists, check if all colors that are part of the include-all rule are also set on the link. If all such colors are not set on the link, the link MUST be pruned from the computation. | Section 13 of [RFC9350]
5 | If the Flex-Algorithm Definition uses something other than the IGP metric (Section 5 of [RFC9350]), and such metric is not advertised for the particular link in a topology for which the computation is done, such link MUST be pruned from the computation. A metric of value 0 MUST NOT be assumed in such a case. | Section 13 of [RFC9350]
6 | Check if any exclude FAEMB rule is part of the Flex-Algorithm definition. If such exclude rule exists and the link has Maximum Link Bandwidth advertised, check if the link bandwidth satisfies the FAEMB rule. If the link does not satisfy the FAEMB rule, the link MUST be pruned from the Flex-Algorithm computation. | Section 6 of [RFC9843]
7 | Check if any exclude FAEMD rule is part of the Flex-Algorithm definition. If such exclude rule exists and the link has Min Unidirectional link delay advertised, check if the link delay satisfies the FAEMD rule. If the link does not satisfy the FAEMD rule, the link MUST be pruned from the Flex-Algorithm computation. | Section 6 of [RFC9843]
8 | Check if any exclude reverse Admin Group rule is part of the Flex-Algorithm definition. If such exclude rule exists, check if any Admin Group that is part of the exclude rule is also set on the link in the reverse direction. If such Admin Group is set on the link in the reverse direction, the link MUST be pruned from the computation. | Section 11 of RFC 9917
9 | Check if any include-any reverse Admin Group rule is part of the Flex-Algorithm definition. If such include-any rule exists, check if any Admin Group that is part of the include-any rule is also set on the link in the reverse direction. If no such Admin Group is set on the link in the reverse direction, the link MUST be pruned from the computation. | Section 11 of RFC 9917
10 | Check if any include-all reverse Admin Group rule is part of the Flex-Algorithm definition. If such include-all rule exists, check if all Admin Groups that are part of the include-all rule are also set on the link in the reverse direction. If all such Admin Groups are not set on the link in the reverse direction, the link MUST be pruned from the computation. | Section 11 of RFC 9917
Guidance for Designated Experts
Since the original Flex-Algorithm specification [RFC9350], many Flex-Algorithm extensions have been proposed and standardized. Many of them added additional rules to the Flex-Algorithm path computation. Maintaining an IANA registry for these rules allows specification across multiple documents progressing independently. The new "IGP Flex-Algorithm Path Computation Rules" registry has been created and is specified in Section 12.3.
This section provides the guidance for designated experts on evaluating new registrations in the "IGP Flex-Algorithm Path Computation Rules" registry:
1. When a new constraint is defined, the rule associated with that constraint MAY be inserted at any position. Backwards compatibility is guaranteed because nodes that don't support the new constraint will not participate in an algorithm where the FAD specifies a constraint they don't support.
2. The relative ordering of existing rules MUST NOT be altered. Doing so has the potential to create backwards compatibility issues.
3. Deletion of the rules MUST NOT be done. Given that the rules are only used conditionally based on the information carried in the winning FAD, deletion of the rule is not necessary.
4. Merging or repeating of the rules MUST NOT be done.
Security Considerations
This document inherits security considerations from [RFC9350].
References
Normative References
Informative References
[RFC9350]
[RFC9843]
[RFC2119]
[RFC8174]
[RFC7308]
[RFC8126]